﻿using Microsoft.AspNetCore.Mvc;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using System.Linq.Dynamic.Core;
using System;
using System.Reflection;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Microsoft.EntityFrameworkCore;
using Schedule.Models;

namespace Schedule.Controllers
{
    public class HomeController : Controller
    {
        private NORTHWNDContext _context;
        public HomeController(NORTHWNDContext context)
        {
            _context = context;
        }

        public IActionResult Index()
        {

        //    List<Orders>  Result = _context.Orders.Take(100).ToList();
         //   ViewBag.datasource = Result;
            return View();
        }
        public List<Orders> GetData()
        {

            List<Orders> datas = _context.Orders.Take(100).ToList();
            return datas;
        }
      public ActionResult Data([FromBody]DataManager dm)
        {
            IEnumerable Data = _context.Orders.Take(100).ToList();

            Syncfusion.JavaScript.DataSources.DataOperations operation = new Syncfusion.JavaScript.DataSources.DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                Data = operation.PerformSorting(Data, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                Data = operation.PerformWhereFilter(Data, dm.Where, dm.Where[0].Operator);
            }
            if (dm.Search != null && dm.Search.Count > 0) //searching
            {
                Data = operation.PerformSearching(Data, dm.Search);
            }

            int count = Data.AsQueryable().Count();
            if (dm.Skip != 0)
            {
                Data = operation.PerformSkip(Data, dm.Skip);
            }
            if (dm.Take != 0)
            {
                Data = operation.PerformTake(Data, dm.Take);
            }
            return Json(new { result = Data, count = count });
        
    }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
            public IEnumerable aggregate { get; set; }
            public IEnumerable groupDs { get; set; }
        }

        public ActionResult CellEditInsert([FromBody]EditParams value)
        {
            var datas = _context;
            datas.Orders.Add(value.value);
            datas.SaveChanges();
            return Json(value);
        }
        public ActionResult CellEditUpdate([FromBody]EditParams value)
        {
            var db = _context;
            db.Entry(value.value).State = EntityState.Modified;
            db.SaveChanges();
            return Json(value);

        }
        public ActionResult CellEditDelete([FromBody]EditParams value)
        {
            var db = _context;
            Orders order = db.Orders.Where(c => c.OrderID == Convert.ToInt32(value.key)).FirstOrDefault();
            db.Orders.Remove(order);
            db.SaveChanges();
            return Json(order);
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
